<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Flujos de Perfil Usuario</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Flujo para un Usuario?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list subheader>
              <v-subheader>Flujos del Perfil</v-subheader>
              <draggable
                v-model="flujosPerfil"
                v-bind="{
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200,
                  disabled: true
                }"
                handle=".drag"
                @change="onDragDrop"
                style="max-height: 200px; min-height: 200px; overflow: auto; border: solid 2px grey;"
              >
                <v-list-group
                  v-for="(flujoPerfil, indexFlujoPerfil) in flujosPerfil"
                  :key="indexFlujoPerfil + 1"
                  no-action
                  class="item"
                >
                  <template v-slot:activator>
                    <v-list-item-icon>
                      <v-icon>mdi-account-lock</v-icon>
                    </v-list-item-icon>
                    <v-list-item-content>
                      <v-list-item-title
                        v-text="
                          serviceCommons.titleCase(
                            flujoPerfil.flujo.descripcion
                          )
                        "
                      />
                    </v-list-item-content>
                  </template>
                  <div class="ml-10">
                    <v-treeview
                      :items="flujoPerfil.flujo.modulos"
                      activatable
                      item-key="id_flujo_modulo"
                      item-text="descripcion"
                      color="primary"
                      open-on-click
                      transition
                    >
                      <template v-slot:label="{ item }">
                        {{ item.descripcion }}
                        <v-avatar
                          v-if="item.children"
                          class="white--text"
                          color="primary"
                          size="20"
                        >
                          {{ item.children.length }}
                        </v-avatar>
                      </template>
                    </v-treeview>
                  </div>
                </v-list-group>
              </draggable>
              <draggable
                v-model="flujosPerfilUsuario"
                v-bind="{
                  group: 'flujos',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200
                }"
                handle=".drag"
                @change="onDragDrop"
                style="min-height: 200px;border: 2px dashed grey;border-top: none;"
              >
                <v-list-group
                  v-for="(flujoPerfilUsuario,
                  indexFlujoPerfilUsuario) in flujosPerfilUsuario"
                  :key="indexFlujoPerfilUsuario + 1"
                  no-action
                  class="item"
                >
                  <template v-slot:activator>
                    <v-list-item-icon>
                      <v-icon
                        @click="
                          deleteAssociateFlujoPerfilUsuario(flujoPerfilUsuario)
                        "
                        >mdi-trash-can</v-icon
                      >
                    </v-list-item-icon>
                    <v-list-item-content>
                      <v-list-item-title
                        v-text="
                          serviceCommons.titleCase(
                            flujoPerfilUsuario.flujo.descripcion
                          )
                        "
                      />
                    </v-list-item-content>
                  </template>
                  <div class="ml-10">
                    <v-treeview
                      :items="flujoPerfilUsuario.flujo.modulos"
                      activatable
                      item-key="id_flujo_modulo"
                      item-text="descripcion"
                      color="primary"
                      open-on-click
                      transition
                    >
                    </v-treeview>
                  </div>
                </v-list-group>
              </draggable>
            </v-list>
          </v-col>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list subheader>
              <v-subheader>Flujos disponibles</v-subheader>
              <draggable
                v-model="flujos"
                v-bind="{
                  group: 'flujos',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200
                }"
                @change="onDragDrop"
                style="max-height: 400px; min-height: 400px; overflow: auto; border: solid 2px grey;"
                handle=".drag"
                @start="drag = true"
                @end="drag = false"
              >
                <transition-group
                  type="transition"
                  :name="!drag ? 'flip-list' : null"
                >
                  <v-list-group
                    class="item"
                    v-for="(flujoPerfil, indexFlujoPerfil) in flujos"
                    :key="indexFlujoPerfil + 'index'"
                    no-action
                  >
                    <template v-slot:activator>
                      <v-list-item-icon>
                        <v-icon class="drag">mdi-cursor-move</v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title
                          v-text="
                            serviceCommons.titleCase(
                              flujoPerfil.flujo.descripcion
                            )
                          "
                        />
                      </v-list-item-content>
                    </template>
                    <v-divider
                      v-if="indexFlujoPerfil + 1 < flujos.length"
                      :key="indexFlujoPerfil + 2"
                    />
                    <div class="ml-10">
                      <v-treeview
                        :items="flujoPerfil.flujo.modulos"
                        activatable
                        item-key="id_flujo_modulo"
                        item-text="descripcion"
                        color="primary"
                        open-on-click
                        transition
                      >
                      </v-treeview>
                    </div>
                  </v-list-group>
                </transition-group>
              </draggable>
            </v-list>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
    </div>
  </div>
</template>
<style scoped>
.button {
  margin-top: 35px;
}
.flip-list-move {
  transition: transform 0.5s;
}
.no-move {
  transition: transform 0s;
}
.ghost {
  opacity: 0.5;
  background: #c8ebfb;
}
.list-group {
  min-height: 20px;
}
.list-group-item {
  cursor: move;
}
.list-group-item i {
  cursor: pointer;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import draggable from "vuedraggable";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-FlujosPerfil",
  components: {
    draggable
  },
  data() {
    return {
      moment: moment,
      drag: null,
      perfil: null,
      usuario: null,
      open: [],
      active: [],
      removedFlujo: null,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Usuarios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_usuario"
          }
        }
      ],
      flujos: [],
      flujosPerfil: [],
      flujosPerfilUsuario: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    initValues() {
      this.breadcrumbs.push({
        text: this.serviceCommons.titleCase(this.usuario.nombre_usuario),
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_usuario",
          params: {
            usuario: this.serviceCommons.objectToBase64(this.usuario)
          }
        }
      });
      this.breadcrumbs.push({
        text: "Perfiles",
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_usuario_perfiles",
          params: {
            usuario: this.serviceCommons.objectToBase64(this.usuario)
          }
        }
      });
      this.breadcrumbs.push({
        text: this.perfil.descripcion,
        disabled: true
      });
      this.breadcrumbs.push({
        text: "Configuracion Flujos",
        disabled: true
      });
    },
    fetchModulosFlujo(itemFlujo) {
      var self = this;
      axios
        .get("/modulo/flujo/secure/get/flujo/tree/" + itemFlujo.id_flujo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              itemFlujo.modulos = [
                {
                  descripcion: "Modulos",
                  children: data
                }
              ];
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getFlujosPerfilUsuarioDisponibles() {
      var self = this;
      const params = {
        id_perfil: this.perfil.id_perfil,
        id_empleado: this.usuario.id_usuario
      };
      axios
        .post("/usuario/secure/flujo/perfil/get/available", params)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujosPerfilUsuarioDisponibles(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujosPerfilUsuarioDisponibles(data) {
      if (data) {
        data.forEach((item) => {
          item.flujo.modulos = [];
        });
        this.flujos = data;
        this.flujos.forEach((item) => {
          this.fetchModulosFlujo(item.flujo);
        });
      }
    },
    getFlujosPerfilAsociados() {
      var self = this;
      axios
        .get("/flujo/perfil/secure/get/associated/" + this.perfil.id_perfil)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujosPerfilAsociados(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujosPerfilAsociados(data) {
      if (data) {
        data.forEach((item) => {
          item.locked = true;
          item.flujo.modulos = [];
        });
        this.flujosPerfil = data;
        this.flujosPerfil.forEach((item) => {
          this.fetchModulosFlujo(item.flujo);
        });
      }
    },
    getFlujosPerfilUsuarioAsociados() {
      var self = this;
      const params = {
        id_perfil: this.perfil.id_perfil,
        id_empleado: this.usuario.id_usuario
      };
      axios
        .post("/usuario/secure/flujo/perfil/get/associated", params)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujosPerfilUsuarioAsociados(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujosPerfilUsuarioAsociados(data) {
      if (data) {
        data.forEach((item) => {
          item.flujo.modulos = [];
        });
        this.flujosPerfilUsuario = data;
        this.flujosPerfilUsuario.forEach((item) => {
          this.fetchModulosFlujo(item.flujo);
        });
      }
    },
    postAssociateFlujoPerfilUsuario(flujo) {
      var self = this;
      flujo.id_empleado = this.usuario.id_usuario;
      flujo.id_flujo = flujo.flujo.id_flujo;
      axios
        .post("/usuario/secure/flujo/perfil/post", flujo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.flujosPerfilUsuario = self.flujosPerfilUsuario.map(
                (item) => {
                  if (item.flujo.id_flujo === data.id_flujo) {
                    item.id_flujo_usuario = data.id_flujo_usuario;
                  }
                  return item;
                }
              );
            } else {
              self.rollbackAdd();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    deleteAssociateFlujoPerfilUsuario(itemToDelete) {
      var self = this;
      axios
        .delete("/usuario/secure/flujo/perfil/delete", { data: itemToDelete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.deleteFlujoPerfilUsuario(itemToDelete);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    rollbackAdd() {
      let itemToAdd = this.removedFlujo.element;
      if (this.flujosPerfilUsuario) {
        this.flujosPerfilUsuario = this.flujosPerfilUsuario.filter((item) => {
          if (item.flujo.id_flujo !== itemToAdd.flujo.id_flujo) {
            return item;
          }
        });
        this.flujos.splice(this.removedFlujo.oldIndex, 0, itemToAdd);
      }
    },
    deleteFlujoPerfilUsuario(itemToDelete) {
      if (this.flujosPerfilUsuario) {
        let flujoPerfilToDelete;
        this.flujosPerfilUsuario = this.flujosPerfilUsuario.filter((item) => {
          if (item.flujo.id_flujo === itemToDelete.flujo.id_flujo) {
            flujoPerfilToDelete = item;
          } else {
            return item;
          }
        });
        if (flujoPerfilToDelete) {
          this.flujos.push(flujoPerfilToDelete);
        }
      }
    },
    onDragDrop(event) {
      if (event.added) {
        this.postAssociateFlujoPerfilUsuario(event.added.element);
      }
      if (event.removed) {
        this.removedFlujo = event.removed;
      }
    },
    onCreated() {
      if (this.$route.params.perfil) {
        this.perfil = this.serviceCommons.base64ToObject(
          this.$route.params.perfil
        );
      }
      if (this.$route.params.usuario) {
        this.usuario = this.serviceCommons.base64ToObject(
          this.$route.params.usuario
        );
      }
      this.initValues();
      this.getFlujosPerfilUsuarioDisponibles();
      this.getFlujosPerfilAsociados();
      this.getFlujosPerfilUsuarioAsociados();
    }
  },
  created() {
    this.onCreated();
  }
};
</script>
